#!/usr/bin/env python
import os
import sys
import traceback

from django.conf import settings
from importlib import import_module
import django


def run():
    os.environ.setdefault("DJANGO_SETTINGS_MODULE", "portail.settings")
    django.setup()

    for app in settings.INSTALLED_APPS:
        if not app.startswith("django"):
            try:
                cron_mod = import_module(app + ".cron")
            except ImportError:
                continue

            if hasattr(cron_mod, "run"):
                try:
                    cron_mod.run()
                except Exception:
                    sys.stderr.write("cron.py: erreur pour l'application {}:\n".format(app))
                    traceback.print_exc()


if __name__ == "__main__":
    run()
